 ;* * * * * * * * * * * * * * * * * * * * * * * * * *
 ;Program name: DIAL.MAC
 ;Creation date: 2 MEI 1987
 ;Update: 17 MAY 1987 NO CARRIER MESSAGE BANDIAL
 ;	  24 MAY 1987 CHECK EMPTY DIALBUF
 ;	  27 MAY 1987 CHECK VALID CHARS IN DIALBUF
 ;Version: V 1.2
 ;Programmer: Bram de Bruine
 ;Program requirements: bytes
 ;Hardware: DOS 65
 ;Purpose: VARIOUS AUTODIALING POSSIBILITIES
 ;Program description: HELPINFO, AUTODIAL
 ;* * * * * * * * * * * * * * * * * * * * * * * * * *
 ;
 ;

	ORG	$A003
 ;
 ;---HELP TEXT---

	FCC $C8,$C5,$CC,$D0
HELP	JSR	PRINT
 FCC $1C,$19
 FCC $0D
 FCC 'Viditel-65 receives, sends and shows videotexpages.\r'
 FCC '\r\rSyntax: VIDITEL FILENAME <CR> \r'
 fcc '\rOption: -M = Enter menumode.\r'
 fcc '\rAbbreviation: VIDI\r'
 FCC '\r\rExample:\r'
 FCC 'To communicate with a host, and making use of the autodialfacility\r'
 FCC 'start the program with: VIDI -M, Autodial and the connection is present.'
 FCC '\r\rTo look at an existing file, just type: VIDI FILE <CR>.'
 FCC '\r'
 FCC '\r'
 FCC 0
 RTS


BBDIAL	LDA	DIALBUF ;DIALBUF EMPTY ?
	BEQ	22.F
	LDX	#0		;CHECK ILLEGAL INPUT
NR1	LDA	DIALBUF,X
	BEQ	3.F		;ALL VERIFIED
	CMP	#$30		;Input <'0
	BMI	ERRDI		;Yes error
	CMP	#$3A		;Input >'9
	BMI	2.F		;No
ERRDI	JMP	ERR		;ERROR
2	INX
	JMP	NR1

3	LDA	HAYES	;Hayes dialer ?
	BEQ	HAYDIAL
	LDA	DIALFLG	;Bansoft dialer ?
	BEQ	BANDIAL
	CMP	#1	;Own dialer ?
	BNE	1.F
	JMP	OWNDIAL
1	JSR	SORRY	;No dialer
	SEC
	RTS
22	JSR	NONU
	SEC
	RTS

ERR	CMP	#','		;Is it `-'
	BNE	ERR1		;No
	INX
	JMP	NR1
ERR1	JSR	MOFF		;Pb6 high (modem off-line)
	JSR	CLEAR23
	TYPE	'\a\EiINPUT ERROR\En'
	SEC			;Error exit
	RTS

HAYDIAL	LDY	#ATD-HAYSTR
	JSR	HAST	;Move string to tranbuf
	LDA	#CR
	JSR	EN2	;Convert 0 to cr
	JSR	RESPONS
	CLC
	RTS


 ;* * * * * * * * * * * * * * * * * * * * * * * * * *
 ;Program name: bandial
 ;Creation date: copied from qmodem4.mac from bansoft enschede
 ;Update: 
 ;Version: 
 ;Programmer: jacques banser
 ;Program requirements: bytes
 ;Hardware: dos 65
 ;Purpose: dial with elektuur dialer
 ;Program description: 
 ;* * * * * * * * * * * * * * * * * * * * * * * * * *
 ;
 ;
BANDIAL	JSR	LASTCLR	;Cursor to lin 24
	JSR	MON		;MODEM ON LINE
	LDX	#$10
1	JSR	DEL100		;Delay 1.6 sec
	DEX
	BNE	1.B
	LDA	DIALBUF,X	;Get first nr

NEWNR1	JSR	OUT		;PRINT TELEPHONE NUMBER
	AND	#$0F
	TAY
	BNE	1.F		;No
	LDY	#$0A		;Yes, --> 10 puls
1	LDA	VIA2
	ORA	#$20		;Xx1x xxxx
	STA	VIA2		;Pb5 `1'
	JSR	DEL100
	LDA	VIA2
	AND	#$DF		;%11011111	xx0x xxxx
	STA	VIA2		;Reset pb5
	DEY			;Number dialt ?
	BNE	1.B		;No
	JSR	DEL100		;Delay time 100ms
	INX			
2	LDA	DIALBUF,X	;Get next number
	BNE	1.F		;No, dial next number
	CLC
	RTS			;**
	MOVEQ	20,VIAVRA	;WAIT 20 SEC
	JSR	DTRON
34	LDA	ACIASR		;CARRIER DETECT ?
	AND	#$20
	BEQ	42.F
	LDA	BREAK		;BRKKEY PRESSED ?
	BEQ	42.F
	LDA	VIAVRA		;TIMEOUT ?
	BNE	34.B
	TYPE	'\a\rNO CARRIER\a\r'
42	CLC
	RTS			;Yes, comp as terminal
1	JMP	NEWNR1

	;Delay for dial a number, t=100ms.
DEL100	JSR	SAVEXY
	LDX	CLOCK	;Clock dependent delay
	CPX	#1	; 1mc
	BEQ	BDEL
	CPX	#2	; 2mc
	BEQ	2.F
	CPX	#3	; 3mc
	BEQ	3.F
	JSR	BDEL	;4 mc
3	JSR	BDEL	;3 mc
2	JSR	BDEL	;2 mc
BDEL	LDX	#0	;1 mc
2	LDY	#0
1	INY
	BNE	1.B
	INX
	CPX	#$57
	BNE	2.B
	JSR	LOADXY
	RTS

DIAPRES	;Test if own dialer implemented
	LDX	#0
2	LDA	DIACOM,X
	CMP	OWNDIAL+6,X
	BNE	1.F
	INX
	CPX	#4
	BNE	2.B
	CLC
	RTS
1	JSR	CLEAR23
	TYPE	'\EiOWN DIALER NOT PRESENT\En'
	SEC
	RTS
DIACOM	FCC	'DIAL'
	
OWNDIAL	JSR	DIAPRES
	JMP	MYDI
	FCC	'XXXX'	;Usually 'dial' if dialer present
MYDI	SEC		;Error exit
	RTS

	END	VIDI
